/*****************************/
/** ITALIANO/TABELLEN       **/
/** (C) Dirk Holtwick, 1995 **/
/*****************************/ 

#include "data.h"

/// Definitions
const char     *artikel[]={"", "il ","lo ","la ","l'","i ","gli ","le ",0};
const short    artikelgen[]={0,0,0,1,0,0,0,1,0};
const char     *KonjSuffixe[ANZKONJS] = {"are","ere","ire"};
const char     *PPErg[ANZKONJS] = {"at","ut","it"};

const char     *aarticles[] = {
					  "a",
					  "e",
					  "i",
					  "o",
					  "u",
					  0
					};

const char     *zarticles[] = {
					  "z",
					  "gn",
					  "ps",
					  "x",
					  "y",
					  "sb",
					  "sc",
					  "sd",
					  "sf",
					  "sg",
					  "sh",
					  "sj",
					  "sk",
					  "sl",
					  "sm",
					  "sn",
					  "sp",
					  "sq",
					  "sr",
					  "st",
					  "sv",
					  "sw",
					  "sx",
					  "sy",
					  "sz",
					  0
					};

char const *GenusStrs[]   = {"m.","f.",""};
char const *Konjugation[] = { "a-Konjugation","e-Konjugation","i-Konjugation","i-Konjugation mit Stammerweiterung"};
char const *Numerus[]     = {"Singular","Plural"};
char const *Genus[]       = {"","Femininum","Maskulinum","Beides"};
char const *Modus[]       = {"Indikativ","Konjunktiv"};
char const *Diathese[]    = {"Aktiv","Passiv"};
char const *Person[]      = {"1. Person","2. Person","3. Person"};
char const *Tempus[]      = {"Prsens","Imperfekt","Futur I"};

char const *FutIrr[]      = {"","ai","","emo","ete","anno"};
char const *CondIrr[]     = {"ei","esti","ebbe","emmo","este","ebbero"};
char const *CPresIrr[]    = {"","","","iamo","iate","no"};
char const *CPerfIrr[]    = {"ssi","ssi","sse","ssimo","ste","ssero"};
///
/// Tempi []

/*
	TEMPI
	***************************************

	DEUTSCH                 ITALIENISCH

	Prsens                 Presente
	Imperfekt               Imperfetto
	Passato remoto          Passato remoto
	Futur I                 Futuro semplice
	Konditional I           Condizionale I
	Imperativ               Imperativo

	Perfekt                 Perfetto
	Plusquamperfekt         Trapassato
	Trapassato remoto       Trapassato remoto
	Futur II                Futuro anteriore
	Konditional II          Condizionale II

	*****************************************
*/

const char *ktab[ANZKONJ][ANZTEMP1][ANZPERS] = {

	// A-KONJUGATION
	// ***********************************
	
	// Prsens
	"o",
	"i",
	"a",
	"iamo",
	"ate",
	"ano",
	
	// Imperfekt
	"avo",
	"avi",
	"ava",
	"avamo",
	"avate",
	"avano",
	
	// Passato remoto
	"ai",
	"asti",
	"",
	"ammo",
	"aste",
	"arono",
	
	// Futur I
	"er",
	"erai",
	"er",
	"eremo",
	"ete",
	"eranno",
	
	// Konditional I
	"erei",
	"eresti",
	"erebbe",
	"eremmo",
	"ereste",
	"erebbero",
	
	// Imperativ
	"",
	"a",
	"i",
	"iamo",
	"ate",
	"ino",
	
	// Prsens Konjunktiv
	"i",
	"i",
	"i",
	"iamo",
	"iate",
	"ino",
	
	// Imperfekt Konjuntiv
	"assi",
	"assi",
	"asse",
	"assimo",
	"aste",
	"assero",
	
	
	
	// E-KONJUGATION
	// ***********************************
	
	// Prsens
	"o",
	"i",
	"e",
	"iamo",
	"ete",
	"ono",
	
	// Imperfekt
	"evo",
	"evi",
	"eva",
	"evamo",
	"evate",
	"evano",
	
	// Passato remoto
	"ei",
	"esti",
	"",
	"emmo",
	"este",
	"erono",
	
	// Futur I
	"er",
	"erai",
	"er",
	"eremo",
	"ete",
	"eranno",
	
	// Konditional I
	"erei",
	"eresti",
	"erebbe",
	"eremmo",
	"ereste",
	"erebbero",
	
	// Imperfekt
	"",
	"i",
	"a",
	"iamo",
	"ete",
	"ano",
	
	// Prsens Konjunktiv
	"a",
	"a",
	"a",
	"iamo",
	"iate",
	"ano",
	
	// Imperfekt Konjuntiv
	"essi",
	"essi",
	"esse",
	"essimo",
	"este",
	"essero",
	
	
	// I-KONJUGATION
	// ***********************************
	
	// Prsens
	"o",
	"i",
	"a",
	"iamo",
	"ite",
	"ono",
	
	// Imperfekt
	"ivo",
	"ivi",
	"iva",
	"ivamo",
	"ivate",
	"ivano",
	
	// Passato remoto
	"ii",
	"isti",
	"",
	"immo",
	"iste",
	"irono",
	
	// Futur I
	"ir",
	"irai",
	"ir",
	"iremo",
	"ite",
	"iranno",
	
	// Konditional I
	"irei",
	"iresti",
	"irebbe",
	"iremmo",
	"ireste",
	"irebbero",
	
	// Imperfekt
	"",
	"i",
	"a",
	"iamo",
	"ite",
	"ano",
	
	// Prsens Konjunktiv
	"a",
	"a",
	"a",
	"iamo",
	"iate",
	"ano",
	
	// Imperfekt Konjuntiv
	"issi",
	"issi",
	"isse",
	"issimo",
	"iste",
	"issero",
	
	
	// I-KONJUGATION mit Stammerweiterung
	// ***********************************
	
	// Prsens
	"isco",
	"isci",
	"isce",
	"iamo",
	"ite",
	"iscono",
	
	// Imperfekt
	"ivo",
	"ivi",
	"iva",
	"ivamo",
	"ivate",
	"ivano",
	
	// Passato remoto
	"ii",
	"isti",
	"",
	"immo",
	"iste",
	"irono",
	
	// Futur I
	"ir",
	"irai",
	"ir",
	"iremo",
	"ite",
	"iranno",
	
	// Konditional I
	"irei",
	"iresti",
	"irebbe",
	"iremmo",
	"ireste",
	"irebbero",
	
	// Imperfekt
	"",
	"isci",
	"isca",
	"iamo",
	"ite",
	"iscano",
	
	// Prsens Konjunktiv
	"isca",
	"isca",
	"isca",
	"iamo",
	"iate",
	"iscano",
	
	// Imperfekt Konjuntiv
	"issi",
	"issi",
	"isse",
	"issimo",
	"iste",
	"issero"
};
///
/// avere []
const char *avere[ANZTEMP2][ANZPERS] = {

	// AVERE
	// ***********************
	
	// fr Perfekt
	"ho",
	"hai",
	"ha",
	"abbiamo",
	"avete",
	"hanno",
	
	// fr Plusquamperfekt
	"avevo",
	"avavi",
	"aveva",
	"avevamo",
	"avevate",
	"avevano",
	
	// fr Trapassato remoto
	"ebbi",
	"avesti",
	"ebbe",
	"avemmo",
	"aveste",
	"ebbero",
	
	// fr Futur II
	"avr",
	"avrai",
	"avr",
	"avremo",
	"avrete",
	"avranno",
	
	// fr Konditional II
	"avrei",
	"avresti",
	"avrebbe",
	"avremmo",
	"avreste",
	"avrebbero",
	
	// fr Perfekt Konjunktiv
	"abbia",
	"abbia",
	"abbia",
	"abbiamo",
	"abbiate",
	"abbiano",
	
	// fr Plusquamperfekt Konjunktiv
	"avessi",
	"avessi",
	"avesse",
	"avessimo",
	"aveste",
	"avessero"

};
///
/// essere []
const char *essere[ANZTEMP2][ANZPERS] = {

	// ESSERE
	// ***********************
	
	// fr Perfekt
	"sono",
	"sei",
	"",
	"siamo",
	"siete",
	"sono",
	
	// fr Plusquamperfekt
	"ero",
	"eri",
	"era",
	"eravamo",
	"eravate",
	"erano",
	
	// fr Trapassato remoto
	"fui",
	"fosti",
	"fu",
	"fummo",
	"foste",
	"furono",
	
	// fr Futur II
	"sar",
	"sarai",
	"sar",
	"saremo",
	"sarete",
	"saranno",
	
	// fr Konditional II
	"sarei",
	"saresti",
	"sarebbe",
	"saremmo",
	"sareste",
	"sarebbero",
	
	// fr Perfekt Konjunktiv
	"sia",
	"sia",
	"sia",
	"siamo",
	"siate",
	"siano",
	
	// fr Plusquamperfekt Konjunktiv
	"fossi",
	"fossi",
	"fosse",
	"fossimo",
	"foste",
	"fossero"

};
///
